#include<bits/stdc++.h>

using namespace std;

long long int n,k,br=0;
long long int a[1000100];

long long int c1[1000100];
long long int c2[1000100];
long long int res[1000100];

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin>>n>>k;
    for(long long int i = 0;i<n;i++) cin>>a[i];

    for(long long int i = 0;i<n;i++) c1[i]=0;
    for(long long int i = 0;i<n;i++) c2[i]=0;

    for(long long int i = 0;i<n;i++){
        if(a[i]>=0) c1[a[i]]++;
        else c2[-1*a[i]]++;
    }
    int j = 0;
    for(long long int i = 0;i<n;i++){
        if(c1[i]>=k){
            br++;
            res[j] = i;
            j++;
        }
    }
    for(long long int i = 0;i<n;i++){
        if(c2[i]>=k){
            br++;
            res[j] = -1*i;
            j++;
        }
    }

    cout<<br<<endl;
    for(long long int i = 0;i<j;i++){
        cout<<res[i]<<" ";
    }
    return 0;
}